'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var React = _interopDefault(require('react'));

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function _toPrimitive(input, hint) {
  if (typeof input !== "object" || input === null) return input;
  var prim = input[Symbol.toPrimitive];

  if (prim !== undefined) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object") return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }

  return (hint === "string" ? String : Number)(input);
}

function _toPropertyKey(arg) {
  var key = _toPrimitive(arg, "string");

  return typeof key === "symbol" ? key : String(key);
}

var context = React.createContext();
var uid = 0;
var queryIDsByQuery = new Map();
function ReactQueryProvider(_ref) {
  var children = _ref.children,
      _ref$config = _ref.config,
      config = _ref$config === void 0 ? {} : _ref$config;
  var metaRef = React.useRef({});

  var _React$useState = React.useState({}),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      state = _React$useState2[0],
      setState = _React$useState2[1];

  var contextValue = React.useMemo(function () {
    return [state, setState, metaRef];
  }, [state]);
  contextValue[3] = _objectSpread({
    retry: 3,
    retryDelay: function retryDelay(attemptIndex) {
      return Math.min(1000 * Math.pow(2, attemptIndex), 30000);
    },
    cacheTime: 10 * 1000,
    inactiveCacheTime: 10 * 1000
  }, config);
  return React.createElement(context.Provider, {
    value: contextValue
  }, children);
}

function useVariables(variablesObj) {
  var stringified = sortedStringify(variablesObj); // eslint-disable-next-line

  return React.useMemo(function () {
    return variablesObj;
  }, [stringified]);
}

function _useQueryContext() {
  return React.useContext(context);
}

function useSharedQuery(_ref2) {
  var query = _ref2.query,
      customQueryID = _ref2.queryID,
      variablesObj = _ref2.variables,
      cache = _ref2.cache,
      instanceID = _ref2.instanceID,
      refetchRef = _ref2.refetchRef,
      queryRetry = _ref2.retry,
      queryRetryDelay = _ref2.retryDelay,
      queryCacheTime = _ref2.cacheTime,
      queryInactiveCacheTime = _ref2.inactiveCacheTime,
      manual = _ref2.manual;

  var _React$useContext = React.useContext(context),
      _React$useContext2 = _slicedToArray(_React$useContext, 4),
      providerState = _React$useContext2[0],
      setProviderState = _React$useContext2[1],
      providerMetaRef = _React$useContext2[2],
      config = _React$useContext2[3]; // Use this cacheBusterRef ID to avoid cache usage


  var cacheBusterRef = React.useRef();

  if (!cacheBusterRef) {
    cacheBusterRef.current = uid++;
  } // Create the final query hash


  var _getQueryInfo = getQueryInfo({
    query: query,
    queryID: customQueryID,
    variables: variablesObj,
    cacheBuster: !cache ? cacheBusterRef.current : ''
  }),
      _getQueryInfo2 = _slicedToArray(_getQueryInfo, 3),
      queryHash = _getQueryInfo2[0],
      queryID = _getQueryInfo2[1],
      variablesHash = _getQueryInfo2[2];

  var variables = useVariables(variablesObj);
  var defaultQueryState = React.useMemo(function () {
    return {
      data: null,
      error: null,
      isFetching: false,
      failureCount: 0,
      isCached: false,
      isStale: true
    };
  }, []);
  var latestRef = React.useRef({});
  var queryState = providerState[queryHash] || defaultQueryState;
  Object.assign(latestRef.current, queryState);
  var setQueryState = React.useCallback(function (updater) {
    return setProviderState(function (old) {
      var oldQueryState = typeof old[queryHash] === 'undefined' ? defaultQueryState : old[queryHash];
      var newValue = typeof updater === 'function' ? updater(oldQueryState) : updater;

      if (typeof newValue === 'undefined') {
        var _ = old[queryHash],
            rest = _objectWithoutProperties(old, [queryHash].map(_toPropertyKey));

        return rest;
      }

      return _objectSpread({}, old, _defineProperty({}, queryHash, newValue));
    });
  }, [setProviderState, queryHash, defaultQueryState]);
  providerMetaRef.current[queryHash] = providerMetaRef.current[queryHash] || {
    queryID: queryID,
    variablesHash: variablesHash,
    promise: null,
    previousDelay: 0,
    instancesByID: {}
  };
  var sharedMeta = providerMetaRef.current[queryHash];
  latestRef.current.config = _objectSpread({}, config, {
    retry: typeof queryRetry !== 'undefined' ? queryRetry : config.retry,
    retryDelay: typeof queryRetryDelay !== 'undefined' ? queryRetryDelay : config.retryDelay,
    cacheTime: typeof queryCacheTime !== 'undefined' ? queryCacheTime : config.cacheTime,
    inactiveCacheTime: typeof queryInactiveCacheTime !== 'undefined' ? queryInactiveCacheTime : config.inactiveCacheTime
  });
  var scheduleCleanup = React.useCallback(function () {
    clearTimeout(sharedMeta.inactiveCacheTimeout);
    setQueryState(function (old) {
      return _objectSpread({}, old, {
        isInactive: true
      });
    });
    sharedMeta.inactiveCacheTimeout = setTimeout(function () {
      setQueryState(undefined);
      clearTimeout(sharedMeta.cacheTimeout);
      delete providerMetaRef.current[queryHash];
    }, latestRef.current.config.inactiveCacheTime);
  }, [providerMetaRef, queryHash, setQueryState, sharedMeta]);
  var doInvalidation = React.useCallback(function () {
    setQueryState(function (old) {
      return _objectSpread({}, old, {
        isStale: true
      });
    });
  }, [setQueryState]);
  var scheduleCacheInvalidation = React.useCallback(function () {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        cleanup = _ref3.cleanup;

    if (cleanup) {
      return scheduleCleanup();
    } else {
      clearTimeout(sharedMeta.cacheTimeout);
    }

    sharedMeta.cacheTimeout = setTimeout(function () {
      // Otherwise, just mark the data as stale
      doInvalidation();
    }, latestRef.current.config.cacheTime);
  }, [sharedMeta, scheduleCleanup, doInvalidation]);
  var tryFetchQueryInstance; // Set up the fetch function

  var tryFetchQuery = tryFetchQueryInstance = React.useCallback(
  /*#__PURE__*/
  function () {
    var _ref5 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee2(_ref4) {
      var variables, data, delay;
      return regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              variables = _ref4.variables;
              _context2.prev = 1;
              _context2.next = 4;
              return query(variables);

            case 4:
              data = _context2.sent;

              if (!sharedMeta.cancelled) {
                _context2.next = 7;
                break;
              }

              throw sharedMeta.cancelled;

            case 7:
              return _context2.abrupt("return", data);

            case 10:
              _context2.prev = 10;
              _context2.t0 = _context2["catch"](1);

              if (!sharedMeta.cancelled) {
                _context2.next = 14;
                break;
              }

              throw sharedMeta.cancelled;

            case 14:
              // If we fail, increase the failureCount
              setQueryState(function (old) {
                return _objectSpread({}, old, {
                  failureCount: old.failureCount + 1
                });
              }); // Do we need to retry the request?

              if (!(latestRef.current.config.retry === true || latestRef.current.failureCount < latestRef.current.config.retry)) {
                _context2.next = 18;
                break;
              }

              // Determine the retryDelay
              delay = typeof latestRef.current.config.retryDelay === 'function' ? latestRef.current.config.retryDelay(latestRef.current.failureCount) : latestRef.current.config.retryDelay; // Return a new promise with the retry

              return _context2.abrupt("return", new Promise(function (resolve, reject) {
                // Keep track of the retry timeout
                setTimeout(
                /*#__PURE__*/
                _asyncToGenerator(
                /*#__PURE__*/
                regeneratorRuntime.mark(function _callee() {
                  var _data;

                  return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          if (!sharedMeta.cancelled) {
                            _context.next = 2;
                            break;
                          }

                          return _context.abrupt("return", reject(sharedMeta.cancelled));

                        case 2:
                          _context.prev = 2;
                          _context.next = 5;
                          return tryFetchQueryInstance({
                            variables: variables
                          });

                        case 5:
                          _data = _context.sent;

                          if (!sharedMeta.cancelled) {
                            _context.next = 8;
                            break;
                          }

                          return _context.abrupt("return", reject(sharedMeta.cancelled));

                        case 8:
                          resolve(_data);
                          _context.next = 16;
                          break;

                        case 11:
                          _context.prev = 11;
                          _context.t0 = _context["catch"](2);

                          if (!sharedMeta.cancelled) {
                            _context.next = 15;
                            break;
                          }

                          return _context.abrupt("return", reject(sharedMeta.cancelled));

                        case 15:
                          reject(_context.t0);

                        case 16:
                        case "end":
                          return _context.stop();
                      }
                    }
                  }, _callee, null, [[2, 11]]);
                })), delay);
              }));

            case 18:
              throw _context2.t0;

            case 19:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, null, [[1, 10]]);
    }));

    return function (_x) {
      return _ref5.apply(this, arguments);
    };
  }(), [query, setQueryState, sharedMeta, tryFetchQueryInstance]);
  var fetchQuery = React.useCallback(
  /*#__PURE__*/
  function () {
    var _ref8 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee4(_ref7) {
      var variables, merge;
      return regeneratorRuntime.wrap(function _callee4$(_context4) {
        while (1) {
          switch (_context4.prev = _context4.next) {
            case 0:
              variables = _ref7.variables, merge = _ref7.merge;

              // Create a new promise for the query cache if necessary
              if (!sharedMeta.promise) {
                sharedMeta.promise = _asyncToGenerator(
                /*#__PURE__*/
                regeneratorRuntime.mark(function _callee3() {
                  var data;
                  return regeneratorRuntime.wrap(function _callee3$(_context3) {
                    while (1) {
                      switch (_context3.prev = _context3.next) {
                        case 0:
                          // If there are any retries pending for this query, kill them
                          sharedMeta.cancelled = false;
                          _context3.prev = 1;
                          // Set up the query refreshing state
                          setQueryState(function (old) {
                            return _objectSpread({}, old, {
                              error: null,
                              isFetching: true,
                              failureCount: 0
                            });
                          }); // Try to fetch

                          _context3.next = 5;
                          return tryFetchQuery({
                            variables: variables
                          });

                        case 5:
                          data = _context3.sent;
                          // Set data and mark it as cached
                          setQueryState(function (old) {
                            return _objectSpread({}, old, {
                              data: merge ? merge(old.data, data) : data,
                              isCached: true,
                              isStale: false
                            });
                          });
                          return _context3.abrupt("return", data);

                        case 10:
                          _context3.prev = 10;
                          _context3.t0 = _context3["catch"](1);

                          if (!(_context3.t0 !== sharedMeta.cancelled)) {
                            _context3.next = 15;
                            break;
                          }

                          // Store the error
                          setQueryState(function (old) {
                            return _objectSpread({}, old, {
                              error: _context3.t0,
                              isCached: false,
                              isStale: true
                            });
                          });
                          throw _context3.t0;

                        case 15:
                          _context3.prev = 15;
                          // Schedule a fresh invalidation, always!
                          scheduleCacheInvalidation();
                          setQueryState(function (old) {
                            return _objectSpread({}, old, {
                              isFetching: false
                            });
                          });
                          delete sharedMeta.promise;
                          return _context3.finish(15);

                        case 20:
                        case "end":
                          return _context3.stop();
                      }
                    }
                  }, _callee3, null, [[1, 10, 15, 20]]);
                }))();
              }

              return _context4.abrupt("return", sharedMeta.promise);

            case 3:
            case "end":
              return _context4.stop();
          }
        }
      }, _callee4);
    }));

    return function (_x2) {
      return _ref8.apply(this, arguments);
    };
  }(), [scheduleCacheInvalidation, setQueryState, sharedMeta, tryFetchQuery]); // Manage query active-ness and garbage collection

  React.useEffect(function () {
    if (sharedMeta.inactiveCacheTimeout) {
      setQueryState(function (_ref10) {
        var isInactive = _ref10.isInactive,
            old = _objectWithoutProperties(_ref10, ["isInactive"]);

        return old;
      });
      clearTimeout(sharedMeta.inactiveCacheTimeout);
    }

    sharedMeta.instancesByID[instanceID] = {
      refetchRef: refetchRef,
      manual: manual
    };
    return function () {
      // Do some cleanup between hash changes
      delete sharedMeta.instancesByID[instanceID];

      if (!Object.keys(sharedMeta.instancesByID).length) {
        sharedMeta.cancelled = {};
        scheduleCacheInvalidation({
          cleanup: true
        });
      }
    };
  }, [instanceID, manual, providerMetaRef, queryHash, refetchRef, scheduleCacheInvalidation, setQueryState, sharedMeta]);
  return _objectSpread({}, queryState, {
    variables: variables,
    fetchQuery: fetchQuery,
    queryHash: queryHash
  });
}

function useQuery(query, _ref11) {
  var userVariables = _ref11.variables,
      customQueryID = _ref11.queryID,
      _ref11$tags = _ref11.tags,
      tags = _ref11$tags === void 0 ? [] : _ref11$tags,
      _ref11$manual = _ref11.manual,
      manual = _ref11$manual === void 0 ? false : _ref11$manual,
      _ref11$cache = _ref11.cache,
      cache = _ref11$cache === void 0 ? true : _ref11$cache,
      cacheTime = _ref11.cacheTime,
      queryRetry = _ref11.retry,
      queryRetryDelay = _ref11.retryDelay,
      queryDisableThrow = _ref11.disableThrow;
  var instanceIDRef = React.useRef(uid++);
  var instanceID = instanceIDRef.current;
  var refetchRef = React.useRef();

  var _useSharedQuery = useSharedQuery({
    query: query,
    queryID: customQueryID,
    tags: tags,
    variables: userVariables,
    cache: cache,
    instanceID: instanceID,
    refetchRef: refetchRef,
    retry: queryRetry,
    retryDelay: queryRetryDelay,
    cacheTime: cacheTime,
    manual: manual
  }),
      data = _useSharedQuery.data,
      error = _useSharedQuery.error,
      isFetching = _useSharedQuery.isFetching,
      isCached = _useSharedQuery.isCached,
      isStale = _useSharedQuery.isStale,
      failureCount = _useSharedQuery.failureCount,
      defaultVariables = _useSharedQuery.variables,
      fetchQuery = _useSharedQuery.fetchQuery,
      queryHash = _useSharedQuery.queryHash;

  var _React$useState3 = React.useState(manual ? false : cache && isCached ? false : true),
      _React$useState4 = _slicedToArray(_React$useState3, 2),
      isLoading = _React$useState4[0],
      setIsLoading = _React$useState4[1];

  var latestRef = React.useRef();
  latestRef.current = {
    isCached: isCached,
    queryDisableThrow: queryDisableThrow,
    isStale: isStale
  };
  var refetch = React.useCallback(
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee5() {
    var _ref13,
        _ref13$variables,
        variables,
        merge,
        _ref13$disableThrow,
        disableThrow,
        _args5 = arguments;

    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _ref13 = _args5.length > 0 && _args5[0] !== undefined ? _args5[0] : {}, _ref13$variables = _ref13.variables, variables = _ref13$variables === void 0 ? defaultVariables : _ref13$variables, merge = _ref13.merge, _ref13$disableThrow = _ref13.disableThrow, disableThrow = _ref13$disableThrow === void 0 ? latestRef.current.queryDisableThrow : _ref13$disableThrow;

            if (!latestRef.current.isCached) {
              setIsLoading(true);
            }

            _context5.prev = 2;
            _context5.next = 5;
            return fetchQuery({
              variables: variables,
              merge: merge
            });

          case 5:
            return _context5.abrupt("return", _context5.sent);

          case 8:
            _context5.prev = 8;
            _context5.t0 = _context5["catch"](2);

            if (!disableThrow) {
              _context5.next = 14;
              break;
            }

            // If throwing is disabled, log the error
            console.error(_context5.t0);
            _context5.next = 15;
            break;

          case 14:
            throw _context5.t0;

          case 15:
            _context5.prev = 15;
            setIsLoading(false);
            return _context5.finish(15);

          case 18:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5, null, [[2, 8, 15, 18]]);
  })), [defaultVariables, fetchQuery]);
  refetchRef.current = refetch;
  React.useEffect(function () {
    if (manual || !latestRef.current.isStale) {
      return;
    }

    var runRefetch =
    /*#__PURE__*/
    function () {
      var _ref14 = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee6() {
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.prev = 0;
                _context6.next = 3;
                return refetch();

              case 3:
                _context6.next = 8;
                break;

              case 5:
                _context6.prev = 5;
                _context6.t0 = _context6["catch"](0);
                console.error(_context6.t0); // Swallow this error. Don't rethrow it into a render function

              case 8:
              case "end":
                return _context6.stop();
            }
          }
        }, _callee6, null, [[0, 5]]);
      }));

      return function runRefetch() {
        return _ref14.apply(this, arguments);
      };
    }();

    runRefetch();
  }, [manual, queryHash, refetch]);
  return {
    data: data,
    error: error,
    isFetching: isFetching,
    isCached: isCached,
    failureCount: failureCount,
    isLoading: isLoading,
    refetch: refetch
  };
}
function useRefetchQueries() {
  var _React$useContext3 = React.useContext(context),
      _React$useContext4 = _slicedToArray(_React$useContext3, 3),
      providerMetaRef = _React$useContext4[2];

  return React.useCallback(
  /*#__PURE__*/
  function () {
    var _ref15 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee10(refetchQueries) {
      var _ref16,
          waitForRefetchQueries,
          _ref16$includeManual,
          defaultIncludeManual,
          refetchQueryPromises,
          _args10 = arguments;

      return regeneratorRuntime.wrap(function _callee10$(_context10) {
        while (1) {
          switch (_context10.prev = _context10.next) {
            case 0:
              _ref16 = _args10.length > 1 && _args10[1] !== undefined ? _args10[1] : {}, waitForRefetchQueries = _ref16.waitForRefetchQueries, _ref16$includeManual = _ref16.includeManual, defaultIncludeManual = _ref16$includeManual === void 0 ? false : _ref16$includeManual;
              refetchQueryPromises = refetchQueries.map(
              /*#__PURE__*/
              function () {
                var _ref17 = _asyncToGenerator(
                /*#__PURE__*/
                regeneratorRuntime.mark(function _callee9(refetchQuery) {
                  var _ref18, query, customQueryID, variables, _ref18$includeManual, includeManual, _getQueryInfo3, _getQueryInfo4, queryID, variablesHash, matchingQueriesPromises;

                  return regeneratorRuntime.wrap(function _callee9$(_context9) {
                    while (1) {
                      switch (_context9.prev = _context9.next) {
                        case 0:
                          _ref18 = typeof refetchQuery === 'function' ? {
                            query: refetchQuery
                          } : typeof refetchQuery === 'string' ? {
                            queryID: refetchQuery
                          } : refetchQuery, query = _ref18.query, customQueryID = _ref18.queryID, variables = _ref18.variables, _ref18$includeManual = _ref18.includeManual, includeManual = _ref18$includeManual === void 0 ? defaultIncludeManual : _ref18$includeManual;
                          _getQueryInfo3 = getQueryInfo({
                            query: query,
                            queryID: customQueryID,
                            variables: variables
                          }), _getQueryInfo4 = _slicedToArray(_getQueryInfo3, 3), queryID = _getQueryInfo4[1], variablesHash = _getQueryInfo4[2];
                          matchingQueriesPromises = Object.keys(providerMetaRef.current).map(
                          /*#__PURE__*/
                          function () {
                            var _ref19 = _asyncToGenerator(
                            /*#__PURE__*/
                            regeneratorRuntime.mark(function _callee8(key) {
                              var query, queryInstancesPromises;
                              return regeneratorRuntime.wrap(function _callee8$(_context8) {
                                while (1) {
                                  switch (_context8.prev = _context8.next) {
                                    case 0:
                                      query = providerMetaRef.current[key];

                                      if (!(!query.queryID === queryID)) {
                                        _context8.next = 3;
                                        break;
                                      }

                                      return _context8.abrupt("return");

                                    case 3:
                                      if (!(variablesHash && query.variablesHash !== variablesHash)) {
                                        _context8.next = 5;
                                        break;
                                      }

                                      return _context8.abrupt("return");

                                    case 5:
                                      queryInstancesPromises = Object.keys(query.instancesByID).map(
                                      /*#__PURE__*/
                                      function () {
                                        var _ref20 = _asyncToGenerator(
                                        /*#__PURE__*/
                                        regeneratorRuntime.mark(function _callee7(id) {
                                          return regeneratorRuntime.wrap(function _callee7$(_context7) {
                                            while (1) {
                                              switch (_context7.prev = _context7.next) {
                                                case 0:
                                                  _context7.prev = 0;

                                                  if (!(query.instancesByID[id].manual && !includeManual)) {
                                                    _context7.next = 3;
                                                    break;
                                                  }

                                                  return _context7.abrupt("return");

                                                case 3:
                                                  _context7.next = 5;
                                                  return query.instancesByID[id].refetchRef.current();

                                                case 5:
                                                  _context7.next = 10;
                                                  break;

                                                case 7:
                                                  _context7.prev = 7;
                                                  _context7.t0 = _context7["catch"](0);
                                                  console.error(_context7.t0); // Swallow this error. Don't leak it out into any render functions

                                                case 10:
                                                case "end":
                                                  return _context7.stop();
                                              }
                                            }
                                          }, _callee7, null, [[0, 7]]);
                                        }));

                                        return function (_x6) {
                                          return _ref20.apply(this, arguments);
                                        };
                                      }());
                                      _context8.next = 8;
                                      return Promise.all(queryInstancesPromises);

                                    case 8:
                                    case "end":
                                      return _context8.stop();
                                  }
                                }
                              }, _callee8);
                            }));

                            return function (_x5) {
                              return _ref19.apply(this, arguments);
                            };
                          }());
                          _context9.next = 5;
                          return Promise.all(matchingQueriesPromises);

                        case 5:
                        case "end":
                          return _context9.stop();
                      }
                    }
                  }, _callee9);
                }));

                return function (_x4) {
                  return _ref17.apply(this, arguments);
                };
              }());

              if (!waitForRefetchQueries) {
                _context10.next = 5;
                break;
              }

              _context10.next = 5;
              return Promise.all(refetchQueryPromises);

            case 5:
            case "end":
              return _context10.stop();
          }
        }
      }, _callee10);
    }));

    return function (_x3) {
      return _ref15.apply(this, arguments);
    };
  }(), [providerMetaRef]);
}
function useUpdateQueries() {
  var _React$useContext5 = React.useContext(context),
      _React$useContext6 = _slicedToArray(_React$useContext5, 2),
      setState = _React$useContext6[1];

  return React.useCallback(function (updaters, data) {
    updaters.forEach(function (updater) {
      var _ref21 = typeof updater === 'function' ? {
        query: updater
      } : typeof updater === 'string' ? {
        queryID: updater
      } : updater,
          query = _ref21.query,
          customQueryID = _ref21.queryID,
          variables = _ref21.variables;

      var _getQueryInfo5 = getQueryInfo({
        query: query,
        queryID: customQueryID,
        variables: typeof variables === 'function' ? variables(data) : variables
      }),
          _getQueryInfo6 = _slicedToArray(_getQueryInfo5, 1),
          queryHash = _getQueryInfo6[0];

      setState(function (old) {
        return _objectSpread({}, old, _defineProperty({}, queryHash, _objectSpread({}, old[queryHash], {
          data: data
        })));
      });
    });
  }, [setState]);
}
function useMutation(mutation) {
  var _ref22 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      defaultRefetchQueries = _ref22.refetchQueries;

  var _React$useState5 = React.useState(null),
      _React$useState6 = _slicedToArray(_React$useState5, 2),
      data = _React$useState6[0],
      setData = _React$useState6[1];

  var _React$useState7 = React.useState(null),
      _React$useState8 = _slicedToArray(_React$useState7, 2),
      error = _React$useState8[0],
      setError = _React$useState8[1];

  var _React$useState9 = React.useState(false),
      _React$useState10 = _slicedToArray(_React$useState9, 2),
      isLoading = _React$useState10[0],
      setIsLoading = _React$useState10[1];

  var refetchQueries = useRefetchQueries();
  var updateQueries = useUpdateQueries();
  var mutate = React.useCallback(
  /*#__PURE__*/
  function () {
    var _ref23 = _asyncToGenerator(
    /*#__PURE__*/
    regeneratorRuntime.mark(function _callee11(variables) {
      var _ref24,
          _ref24$refetchQueries,
          userRefetchQueries,
          userUpdateQueries,
          waitForRefetchQueries,
          disableThrow,
          res,
          _args11 = arguments;

      return regeneratorRuntime.wrap(function _callee11$(_context11) {
        while (1) {
          switch (_context11.prev = _context11.next) {
            case 0:
              _ref24 = _args11.length > 1 && _args11[1] !== undefined ? _args11[1] : {}, _ref24$refetchQueries = _ref24.refetchQueries, userRefetchQueries = _ref24$refetchQueries === void 0 ? defaultRefetchQueries : _ref24$refetchQueries, userUpdateQueries = _ref24.updateQueries, waitForRefetchQueries = _ref24.waitForRefetchQueries, disableThrow = _ref24.disableThrow;
              setIsLoading(true);
              setError(null);
              _context11.prev = 3;
              _context11.next = 6;
              return mutation(variables);

            case 6:
              res = _context11.sent;
              setData(res);

              if (!userRefetchQueries) {
                _context11.next = 11;
                break;
              }

              _context11.next = 11;
              return refetchQueries(userRefetchQueries, {
                waitForRefetchQueries: waitForRefetchQueries
              });

            case 11:
              if (userUpdateQueries) {
                updateQueries(userUpdateQueries, res);
              }

              return _context11.abrupt("return", res);

            case 15:
              _context11.prev = 15;
              _context11.t0 = _context11["catch"](3);
              setError(_context11.t0);

              if (!disableThrow) {
                _context11.next = 22;
                break;
              }

              console.error(_context11.t0);
              _context11.next = 23;
              break;

            case 22:
              throw _context11.t0;

            case 23:
              _context11.prev = 23;
              setIsLoading(false);
              return _context11.finish(23);

            case 26:
            case "end":
              return _context11.stop();
          }
        }
      }, _callee11, null, [[3, 15, 23, 26]]);
    }));

    return function (_x7) {
      return _ref23.apply(this, arguments);
    };
  }(), [defaultRefetchQueries, mutation, refetchQueries, updateQueries]);
  return [mutate, {
    data: data,
    isLoading: isLoading,
    error: error
  }];
}
function useIsFetching() {
  var _React$useContext7 = React.useContext(context),
      _React$useContext8 = _slicedToArray(_React$useContext7, 1),
      state = _React$useContext8[0];

  return React.useMemo(function () {
    return Object.keys(state).some(function (key) {
      return state[key].isFetching;
    });
  }, [state]);
}
function useRefetchAll() {
  var _ref25 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      defaultDisableThrow = _ref25.disableThrow,
      defaultIncludeManual = _ref25.includeManual;

  var _React$useContext9 = React.useContext(context),
      _React$useContext10 = _slicedToArray(_React$useContext9, 3),
      metaRef = _React$useContext10[2];

  return React.useCallback(
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee12() {
    var _ref27,
        _ref27$disableThrow,
        disableThrow,
        _ref27$includeManual,
        includeManual,
        promises,
        _args12 = arguments;

    return regeneratorRuntime.wrap(function _callee12$(_context12) {
      while (1) {
        switch (_context12.prev = _context12.next) {
          case 0:
            _ref27 = _args12.length > 0 && _args12[0] !== undefined ? _args12[0] : {}, _ref27$disableThrow = _ref27.disableThrow, disableThrow = _ref27$disableThrow === void 0 ? defaultDisableThrow : _ref27$disableThrow, _ref27$includeManual = _ref27.includeManual, includeManual = _ref27$includeManual === void 0 ? defaultIncludeManual : _ref27$includeManual;
            promises = Object.keys(metaRef.current).map(function (key) {
              var promises = Object.keys(metaRef.current[key].instancesByID).map(function (key2) {
                if (metaRef.current[key].instancesByID[key2].manual && !includeManual) {
                  return Promise.resolve();
                }

                return metaRef.current[key].instancesByID[key2].refetchRef.current();
              });
              return Promise.all(promises);
            });
            _context12.prev = 2;
            _context12.next = 5;
            return Promise.all(promises);

          case 5:
            _context12.next = 14;
            break;

          case 7:
            _context12.prev = 7;
            _context12.t0 = _context12["catch"](2);

            if (!disableThrow) {
              _context12.next = 13;
              break;
            }

            console.error(_context12.t0);
            _context12.next = 14;
            break;

          case 13:
            throw _context12.t0;

          case 14:
          case "end":
            return _context12.stop();
        }
      }
    }, _callee12, null, [[2, 7]]);
  })), [defaultDisableThrow, defaultIncludeManual, metaRef]);
} // Utils

function getQueryID(query, customQueryID) {
  // Get a query ID for this query function
  var queryID = customQueryID || queryIDsByQuery.get(query); // Make the queryID if necessary

  if (!queryID) {
    queryIDsByQuery.set(query, uid++);
    queryID = queryIDsByQuery.get(query);
  }

  return queryID;
}

function getQueryInfo(_ref28) {
  var query = _ref28.query,
      customQueryID = _ref28.queryID,
      variablesObj = _ref28.variables,
      _ref28$cacheBuster = _ref28.cacheBuster,
      cacheBuster = _ref28$cacheBuster === void 0 ? '' : _ref28$cacheBuster;
  var queryID = getQueryID(query, customQueryID);
  var variablesHash = sortedStringify(variablesObj);
  return [[queryID, variablesHash, cacheBuster].join(''), queryID, variablesHash];
}

function sortedStringifyReplacer(_, value) {
  return value === null || _typeof(value) !== 'object' || Array.isArray(value) ? value : Object.assign.apply(Object, [{}].concat(_toConsumableArray(Object.keys(value).sort(function (keyA, keyB) {
    return keyA > keyB ? 1 : keyB > keyA ? -1 : 0;
  }).map(function (key) {
    return _defineProperty({}, key, value[key]);
  }))));
}

function sortedStringify(obj) {
  return JSON.stringify(obj, sortedStringifyReplacer);
}

exports.ReactQueryProvider = ReactQueryProvider;
exports._useQueryContext = _useQueryContext;
exports.useIsFetching = useIsFetching;
exports.useMutation = useMutation;
exports.useQuery = useQuery;
exports.useRefetchAll = useRefetchAll;
exports.useRefetchQueries = useRefetchQueries;
exports.useUpdateQueries = useUpdateQueries;
//# sourceMappingURL=index.js.map
